//
//  TodoTableViewCell.swift
//  IFS
//
//  Created by 曹云霄 on 2018/1/5.
//  Copyright © 2018年 上海勾芒信息科技有限公司. All rights reserved.
//

import UIKit

class TodoTableViewCell: UITableViewCell {

    /// 内容
    @IBOutlet weak var contentLabel: UILabel!
    /// 标题 + code
    @IBOutlet weak var titleCodeLabel: UILabel!
    /// 操作时间
    @IBOutlet weak var operationDateLabel: UILabel!
    /// 状态
    @IBOutlet weak var todoStateLabel: UILabel!
    
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
    }

    // MARK: - 更新待办cell
    func updateTodoCell(_ model: TodoData, _ indexPath: IndexPath) {
        if model.entityType == .work{
            titleCodeLabel.text = "工单单号:" + (model.workNo == "" ? "无数据" : model.workNo)
        }else{
            let titleString = model.dept.code != "" ? "(\(model.dept.code ?? ""))" : " "
            titleCodeLabel.text = model.dept.name + titleString
        }
        operationDateLabel.text = String(format: "%@", model.createTime)
        todoStateLabel.text = model.workState.getStateString()
        contentLabel.text = model.content
    }

}
